(in-package :decentralise-standard-system)

(defgeneric connection-interested-in-p (system connection name version channels)
  (:method ((system standard-system) connection name version channels)
    (declare (ignore name version))
    (channel-set-interested-p (connection-channel-set system connection)
                              channels)))

(define-time-meter *distribute-meter* "Broadcasting metadata" "standard-system")
(defgeneric broadcast-metadata (system name version channels)
  (:documentation "Broadcast metadata about a new object to all interested connections.")
  (:method ((system standard-system) name version channels)
    (with-time-meter (*distribute-meter*)
      (let ((connections-to-notify '()))
        (with-unlocked-box (connections (system-subscribed-connections system))
          (dolist (connection connections)
            (when (connection-interested-in-p system connection name version channels)
              (push connection connections-to-notify))))
        (dolist (connection connections-to-notify)
          (ignore-errors
           (decentralise-connection:write-subscription connection name version channels)))))))

(defgeneric distribute-after-put-block (system name version channels)
  (:method ((system standard-system) name version channels)
    (broadcast-metadata system name version channels)))
